package com.gxzc.zen.io

import com.gxzc.zen.common.util.io.BufferedRandomAccessFile
import org.junit.Test

/**
 *
 * @author NorthLan
 * @date 2018/9/1
 * @url https://noahlan.com
 */
class BufferedRandomAccessFileTest {

    @Test
    fun test() {
        val readfilelen: Long
        val brafReadFile = BufferedRandomAccessFile("D:\\gradle-4.9-bin.zip")
        val brafWriteFile = BufferedRandomAccessFile("D:\\gradle-4.9-bin-bak.zip", "rw", 10)

        readfilelen = brafReadFile.initfilelen

        val buf = ByteArray(4096)
        var readcount: Int = brafReadFile.read(buf)

        var start = System.currentTimeMillis()

        while (readcount != -1) {
            brafWriteFile.write(buf, 0, readcount)
            readcount = brafReadFile.read(buf)
        }

        brafWriteFile.close()
        brafReadFile.close()

        println("BufferedRandomAccessFile Copy & Write File: "
                + brafReadFile.filename
                + "    FileSize: "
                + java.lang.Integer.toString(readfilelen.toInt() shr 4096)
                + " (KB)    "
                + "Spend: "
                + (System.currentTimeMillis() - start).toDouble() / 1000
                + "(s)")

        val fdin = java.io.FileInputStream("D:\\gradle-4.9-bin.zip")
        val bis = java.io.BufferedInputStream(fdin, 4096)
        val dis = java.io.DataInputStream(bis)

        val fdout = java.io.FileOutputStream("D:\\gradle-4.9-bin-bak2.zip")
        val bos = java.io.BufferedOutputStream(fdout, 4096)
        val dos = java.io.DataOutputStream(bos)

        start = System.currentTimeMillis()

        for (i in 0 until readfilelen) {
            dos.write(dis.readByte().toInt())
        }

        dos.close()
        dis.close()

        println("DataBufferedios Copy & Write File: "
                + brafReadFile.filename
                + "    FileSize: "
                + java.lang.Integer.toString(readfilelen.toInt() shr 4096)
                + " (KB)    "
                + "Spend: "
                + (System.currentTimeMillis() - start).toDouble() / 1000
                + "(s)")
    }
}